require 'stringio'
fio = StringIO.new('')
register = StringIO.new('')

type = name = args = interface = nil
commands = []

def c2ruby(name, types)
  case types[name]
  when 'GtkTreeIter*'
    "ITR2RVAL(#{name})"
  when 'GtkTreePath*'
    "TREEPATH2RVAL(#{name})"
  when 'int','gint'
    "INT2NUM(#{name})"
  else
    puts types[name].inspect, name.inspect
  end
end

for line in IO.readlines("treemodel.iface")
  line.strip!
  #p line
  if line =~ /^interface ([A-Za-z]+)/
    interface = $1
  fio.puts "void"
  fio.puts "rbglib_#{interface}__interface_init(gpointer g_iface, gpointer iface_data);\n\n"
  elsif line =~ /([a-zA-Z*]+) ([a-z_]+) [(]([^)]*)[)]/
    type, name, rargs = $1, $2, $3.strip
    args = []
    argtypes = {}
    unless rargs.empty?
    args = rargs.split(/,/).collect { |arg|
      if arg.strip =~ /^([A-Za-z_]+[ *]{1,})([a-z]+)$/
        t,n = $1, $2
        argtypes[n] = t.gsub(/\s+/,'')
        n
      else
        STDERR.puts "Unrecognised argument: #{arg.inspect}"
        nil
      end
    }.compact
    end
  elsif line.empty?
    if type and not commands.empty?
      fio.puts "static #{type} rb_#{interface}_#{name}(#{interface} *_self#{rargs.empty? ? '' : ', '+rargs})"
      fio.puts "{"
      fio.puts "    static ID iface_symbol = 0;"
      fio.puts "    if (iface_symbol == 0) iface_symbol = rb_intern(#{name.inspect});"
      until commands.empty?
      cline = commands.shift
      com = cline.gsub(/\<[.a-z_,]+\>/) { |i|
        cargs = i[1..-2]
        if cargs == '...'
          cargs = args
        else
          cargs = cargs.split(/,/)
        end
        "rbgobj_iface_dispatch(GOBJ2RVAL(_self), iface_symbol, rb_ary_new3(#{cargs.size}#{cargs.collect { |arg| ', '+c2ruby(arg, argtypes) }.join}))"
      }
      fio.write "    "
      fio.write "return " if commands.empty? and type != "void"
      fio.puts com + ";"
      end
      fio.puts "}\n\n"
      register.puts "    klass->#{name} = rb_#{interface}_#{name};"
    end
    
    commands= []
  else
    # Process line
    commands << line
  end
end

fio.puts "void"
fio.puts "rbglib_#{interface}__interface_init(gpointer g_iface, gpointer iface_data)"
fio.puts "{"
fio.puts "    #{interface}Iface *klass = (#{interface}Iface *) g_iface;"
fio.puts register.string
fio.puts "}"


STDOUT << fio.string
