require 'gtk2'

class ArrayStore < Gtk::Object
  register_type
  implements Gtk::TreeModel
  attr_accessor :store
  def initialize()
    super()
    @store = []
  end
  def get_flags()
    #p caller(0)[0], []
    Gtk::TreeModel::Flags::LIST_ONLY
  end
  def get_n_columns()
    #p caller(0)[0], []
    1
  end
  def get_column_type(i)
    #p caller(0)[0], [i]
    String
  end
  def get_iter(path)
    #p caller(0)[0], [path]
    i = path.to_str.to_i
    #p [i, path.to_str]
    if i < @store.size
      iter = Gtk::TreeIter.new(self)
      iter.stamp = @store.hash
      iter.user_data = i
      iter
    else
      Qnil
    end
  end
  def get_path(iter)
    #p caller(0)[0], [path]
    Gtk::TreePath.new(iter.user_data.to_s)
  end
  def get_value(iter, col)
    #p caller(0)[0], [iter, col]
    @store[iter.user_data]
  end
  def iter_next(iter)
    #p caller(0)[0], [iter]
    if iter.user_data < (@store.size - 1)
      #p iter.user_data
      iter.user_data = iter.user_data + 1
      #p iter.user_data
      iter
    else
      nil
    end
  end
  def iter_children(iter)
    #p caller(0)[0], [iter]
    nil
  end
  def iter_has_child(iter)
    #p caller(0)[0], [iter]
    nil
  end
  def iter_n_children(iter)
    #p caller(0)[0], [iter]
    0
  end
  def iter_nth_child(iter,n)
    #p caller(0)[0], [iter]
    nil
  end
  def iter_parent(iter)
    #p caller(0)[0], [iter]
    nil
  end
  def ref_node(iter)
    #p caller(0)[0], [iter]
    nil
  end
  def unref_node(iter)
    #p caller(0)[0], [iter]
    nil
  end
end

Gtk.init

model = ArrayStore.new
model.store = %w[my name is MY NAME IS]

view = Gtk::TreeView.new(model)
view.append_column(Gtk::TreeViewColumn.new("Word", Gtk::CellRendererText.new, {:text=>0}))

w = Gtk::Window.new
w.add(view)
w.show_all
w.signal_connect('delete-event') { Gtk::main_quit }

Gtk.main

